# special packages can be placed in the profile
# directory under lib 

# define only procs hereafter
# 
proc Init {root nspace} {
  
  variable rf 
  variable ns
  set rf $root 
  set ns $nspace

  ttk::label $root.headline -text "Press the button to load XGrabber"

  ttk::button $root.fire -text "Fire" -command ${ns}::initxgrabber

  pack $root.headline $root.fire
  return "Snapshot"
}


# 
proc initxgrabber {} {
  variable rf
  variable ns
  variable liverunning
  # this might crash 
  # TODO: FIX finally xgrabber !!
  #
  #
  package require xgrabber
  destroy $rf.headline $rf.fire
  ttk::button $rf.shoot -text "Take picture" -command ${ns}::shoot
  ttk::checkbutton $rf.live -text "Show LIVE" -variable ${ns}::liverunning -command ${ns}::togglelive
  ttk::button $rf.save -text "Save latest snapshot" -command ${ns}::save
  set liverunning 0
  pack $rf.shoot $rf.live $rf.save
  
  ttk::label $rf.ftlabel -text "Exposure time"
  
  set expnr 0
  variable frametime 2
  setframetime
  foreach t {134 200 400 800} {
    pack [ttk::radiobutton $rf.frt$expnr -text "$t ms" -variable ${ns}::frametime -value $expnr -command ${ns}::setframetime]
    incr expnr
  }


}

proc setframetime {} {
  variable frametime
  XR_set_frame_time $frametime
}


proc ::snapshot {title} {
  bild16 snap16
  aufnahme snap16
  # XRlab BUG:: Namespace fehlt fuer filterprocs
  namespace eval ::XRlab {
   set ::snapoutput [$filterprocs($activefilter) snap16]
  }
  show $::snapoutput $title
  
}

proc livebild {} {
  variable liverunning
  variable liveid
  variable ns
  snapshot LIVE
  set liveid [after 1000 ${ns}::livebild]
}

proc stoplivebild {} {
  variable liveid
  variable liverunning
  after cancel $liveid 
}

proc shoot {} {
  variable liverunning
  if {$liverunning} {
   # simply grasp the latest live frame
   bild16 SNAPSHOT snap16
  } else {
    # take a shot 
    snapshot SCHUSS
    bild16 SNAPSHOT snap16
  }  

}

proc togglelive {} {
 variable liverunning
 if {$liverunning} {
  livebild
 } else {
  stoplivebild
 }  
}

proc save {} {

  set name [tk_getSaveFile]
  if {$name != ""} {
    SNAPSHOT write_his $name
  }  
}
